<?php
namespace nur\sery\wip\php\access;

use nur\sery\cl;

/**
 * Class PostAccess: accès à une valeur de $_POST
 */
class PostAccess extends FormAccess {
  function exists(): bool {
    $key = $this->key;
    if ($key === null) return false;
    return array_key_exists($key, $_POST);
  }

  public function available(): bool {
    $key = $this->key;
    if ($key === null) return false;
    if (array_key_exists($key, $_POST)) {
      return $this->allowEmpty || $_POST[$key] !== "";
    } else {
      return false;
    }
  }

  function get($default=null) {
    $key = $this->key;
    if ($key === null) return $default;
    if (array_key_exists($key, $_POST)) {
      $value = $_POST[$key];
      if ($value === "" && !$this->allowEmpty) return $default;
      return $value;
    } else {
      return $default;
    }
  }

  function set($value): void {
    $key = $this->key;
    if ($key === null) return;
    cl::set($_POST, $key, $value);
  }

  function del(): void {
    $key = $this->key;
    if ($key === null) return;
    cl::del($_POST, $key);
  }
}
